package com.its.api.bis.service;

import com.its.api.bis.model.dto.BitStatusHistoryDto;
import com.its.api.bis.model.entity.BitStatusHistory;
import com.its.api.bis.model.entity.BitStatusHistoryKey;
import com.its.api.bis.repository.BitStatusHistoryRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;

@Slf4j
@RequiredArgsConstructor
@Service
public class BitStatusHistoryService {

    private final BitStatusHistoryRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private BitStatusHistory requireOne(BitStatusHistoryKey id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<BitStatusHistoryDto> findAll() {
        List<BitStatusHistoryDto> result = new ArrayList<>();
        List<BitStatusHistory> data = this.repo.findAll();
        for (BitStatusHistory entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public BitStatusHistoryDto findById(BitStatusHistoryKey id) {
        BitStatusHistory entity = requireOne(id);
        return entity.toDto();
    }

}
